/* Import plugin specific language pack */
tinyMCE.importPluginLanguagePack('drupalvoting', 'en');

function TinyMCE_drupalvoting_initInstance(inst) {
	if (!tinyMCE.settings['drupalvoting_skip_plugin_css']) {
		tinyMCE.importCSS(inst.getDoc(), tinyMCE.baseURL + "/plugins/drupalvoting/drupalvoting.css");
	}
}

function TinyMCE_drupalvoting_getControlHTML(control_name) {
  switch (control_name) {
    case "drupalvoting":
      return '<img id="{$editor_id}_drupalvoting" src="{$pluginurl}/images/onestar.gif" title="{$lang_insert_drupalvoting}" width="20" height="20" class="mceButtonNormal" onmouseover="tinyMCE.switchClass(this,\'mceButtonOver\');" onmouseout="tinyMCE.restoreClass(this);" onmousedown="tinyMCE.restoreAndSwitchClass(this,\'mceButtonDown\');tinyMCE.execInstanceCommand(\'{$editor_id}\',\'mceDrupalVoting\');" />';
  }
  return "";
}

function TinyMCE_drupalvoting_execCommand(editor_id, element, command, user_interface, value) {
	function getAttrib(elm, name) {
		return elm.getAttribute(name) ? elm.getAttribute(name) : "";
	}

  // Handle commands
  switch (command) {
    case "mceDrupalVoting":
			var name = "";
			var voting_type = "", voting_prompt = "", voting_confirmation = "";
			var action = "insert";
      var template = new Array();
			var inst = tinyMCE.getInstanceById(editor_id);
			var focusElm = inst.getFocusElement();

			template['file']   = '../../plugins/drupalvoting/drupalvoting.htm'; // Relative to theme
			template['width']  = 400;
			template['height'] = 195;

			// Is an existing voting control already selected?
      if (focusElm != null && focusElm.nodeName.toLowerCase() == "img") {
				name = getAttrib(focusElm, 'name');

				if (name != 'mce_plugin_drupalvoting') { // image is not a Voting placeholder
					return true;
				}
	
				// parse the rest of the voting control attributes
				var attributes = new Array();
				var attribs = getAttrib(focusElm, 'alt');		
				var regExp = new RegExp("([a-zA-Z]*)=([^\|]+)", "g"); // doesn't work without global (g)
				var matches = attribs.match(regExp);
				for (var i = 0; i < matches.length; i++ ) {
						keyvalue_arr = matches[i].split('=');
						attributes[keyvalue_arr[0]] = keyvalue_arr[1];
				}
				
				voting_type = attributes['type'];
				voting_prompt = attributes['prompt'];
				voting_confirmation = attributes['confirmation'];
				action = "update";
      }

   		tinyMCE.openWindow(template, {editor_id : editor_id, voting_type : voting_type, voting_prompt : voting_prompt, voting_confirmation : voting_confirmation, action : action});
			return true;
  }

	// Pass to next handler in chain
	return false;
}

function TinyMCE_drupalvoting_cleanup(type, content) {
	switch (type) {
		case "insert_to_editor_dom":
			var imgs = content.getElementsByTagName("img");
			for (var i=0; i<imgs.length; i++) {
				if (tinyMCE.getAttrib(imgs[i], "class") == "mce_plugin_drupalvoting") { // fixed bug, changed 'name' to 'class' by Ben Shell
					var src = tinyMCE.getAttrib(imgs[i], "alt");

					src = tinyMCE.convertRelativeToAbsoluteURL(tinyMCE.settings['base_href'], src);

					imgs[i].setAttribute('alt', src);
				}
			}
			break;

		case "get_from_editor_dom":
			var imgs = content.getElementsByTagName("img");
			for (var i=0; i<imgs.length; i++) {
				if (tinyMCE.getAttrib(imgs[i], "name") == "mce_plugin_drupalvoting") {
					var src = tinyMCE.getAttrib(imgs[i], "alt");

					src = eval(tinyMCE.settings['urlconverter_callback'] + "(src, null, true);");

					imgs[i].setAttribute('alt', src);
				}
			}
			break;

		case "insert_to_editor":
			var startPos = 0;

			// Parse all drupalvoting filter tags and replace them with images
			var index = 0;
			while ((startPos = content.indexOf('[voting|', startPos)) != -1) {
				// Find end of object
				endPos = content.indexOf(']', startPos);
				
				//var attribs = TinyMCE_drupalvoting_parseAttributes(content.substring(startPos + 8, endPos));
				var attribs = content.substring(startPos + 8, endPos);
				
				// Insert image
				var contentAfter = content.substring(endPos + 1);
				content = content.substring(0, startPos);
				content += '<img name="mce_plugin_drupalvoting" width="210" height="35"';
				content += ' src="' + (tinyMCE.getParam("theme_href") + '/images/spacer.gif') + '" title="' + attribs + '"';
				content += ' alt="' + attribs + '" class="mce_plugin_drupalvoting" />';
				content += contentAfter;
				index++;

				startPos++;
			}
			break;

		case "get_from_editor":
			// Parse all img tags and replace them with drupalvoting filter
			var startPos = -1;
			while ((startPos = content.indexOf('<img', startPos+1)) != -1) {
				var endPos = content.indexOf('/>', startPos);
				var attribs = TinyMCE_drupalvoting_parseAttributes(content.substring(startPos + 4, endPos));
				endPos += 2;
				
				// Is not drupalvoting, skip it
				if (attribs['class'] != "mce_plugin_drupalvoting") // changed to "class" from "name" by Ben Shell
					continue;
				
				// Insert drupalvoting filter code
				contentBefore = content.substring(0, startPos);
				contentAfter = content.substring(endPos);
				content = contentBefore + '[voting|' + attribs["title"] + ']' + contentAfter;
			}
			break;
	}

	// Pass through to next handler in chain
	return content;
}

function TinyMCE_drupalvoting_handleNodeChange(editor_id, node, undo_index, undo_levels, visual_aid, any_selection) {
	function getAttrib(elm, name) {
		return elm.getAttribute(name) ? elm.getAttribute(name) : "";
	}

	tinyMCE.switchClassSticky(editor_id + '_drupalvoting', 'mceButtonNormal');

	if (node == null)
		return;

	do {
		if (node.nodeName.toLowerCase() == "img" && getAttrib(node, 'name').indexOf('mce_plugin_drupalvoting') == 0)
			tinyMCE.switchClassSticky(editor_id + '_drupalvoting', 'mceButtonSelected');
	} while ((node = node.parentNode));

	return true;
}

/**
	* TinyMCE_drupalvoting_parseAttributes()
	* Uses regular expressions to parse key="value" strings into an array.
  */ 
function TinyMCE_drupalvoting_parseAttributes(attribute_string) {
	var attributes = new Array();
	var regExp = "([a-zA-Z0-9]+)[\s]*=[\s]*['\"]([^\"']*)['\"]";
	
	var outerRegExp = new RegExp(regExp, "g"); // doesn't work without global (g)
	var outerMatches = attribute_string.match(outerRegExp);
	var innerRegExp = new RegExp(regExp); // doesn't work with global (g)
	for (var i = 0; i < outerMatches.length; i++ ) {
		innerMatches = innerRegExp.exec(outerMatches[i]);
		attributes[innerMatches[1]] = innerMatches[2];
	}
	return attributes;
}